varying	vec3 lt;
varying	vec3 ht;
varying	vec3 p;

uniform sampler2D cellMap;
uniform sampler2D rainbowMap;

vec2	grad ( const in vec2 tex )
{
	vec3	f00 = texture2D ( cellMap, tex ).xyz;
	vec3	f01 = texture2D ( cellMap, tex + vec2 ( 0.01, 0.0 ) ).xyz;
	vec3	f10 = texture2D ( cellMap, tex + vec2 ( 0.0, 0.01 ) ).xyz;
	
	return 5.0*vec2 ( ( f01 - f00 ).x, (f10 - f00 ).x );
}

vec2	grad2 ( const in vec2 tex )
{
	vec3	f00 = texture2D ( cellMap, tex ).xyz;
	vec3	f01 = texture2D ( cellMap, tex + vec2 ( 0.01, 0.0 ) ).xyz;
	vec3	f10 = texture2D ( cellMap, tex + vec2 ( 0.0, 0.01 ) ).xyz;
	
	vec3	df1 = f01 - f00;
	vec3	df2 = f10 - f00;
	
	return 3.0*vec2 ( df1.y - df1.x, df2.x - df2.y );
}

void main(void)
{
	vec2	tex = 0.5*vec2 ( 1.0, 2.0 ) * gl_TexCoord [0].xy;
	vec4	f   = texture2D ( cellMap, tex );

/*
	float	v = f.x;
	float	t = ceil ( 7*v )/7.0;
	
	gl_FragColor = texture2D ( rainbowMap, vec2 ( t, 0 ) );
*/	
//	float	v = clamp ( f.y - f.x, 0, 1 ) + clamp ( f.z - f.y, 0, 1 );
//	float	v = 2*f.y*(f.y-f.x);
	float	v = f.x + f.y - f.x*f.y;
//	float	v = grad  ( tex ) + 0.5;
//	float	v = grad2 ( tex ) + 0.5;

    vec3	 n       = vec3 ( 0.0, 0.0, 1.0 );
    vec3     nn      = normalize ( n - 7.0*vec3 ( grad2 ( tex ), 0.0 ) );
    vec3     ln      = normalize ( lt );
    vec3     hn      = normalize ( ht );
    float    diffuse = 0.4 + max ( 0.0, dot ( nn, ln ) );
    float    spec    = 0.5*pow ( max ( 0.0, dot ( nn, hn ) ), 30.0 );
	
	gl_FragColor = vec4 ( vec3 ( diffuse ), 1.0 );	
}